import { createContext, useContext } from 'react';
export const PlotContext = createContext({
    xScientific: false,
    yScientific: false,
});
export const DispatchContext = createContext({
    dispatch: null,
});
export function usePlotContext() {
    const context = useContext(PlotContext);
    if (!context) {
        throw new Error('Plot compound component outside Plot context');
    }
    return context;
}
export function useDispatchContext() {
    const context = useContext(DispatchContext);
    if (!context) {
        throw new Error('Plot compound component outside Dispatch context');
    }
    return context;
}
//# sourceMappingURL=hooks.js.map