"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const hooks_1 = require("../hooks");
function yTranslation(position, height) {
    switch (position) {
        case 'top': {
            return 20;
        }
        case 'bottom': {
            return height + 64;
        }
        default: {
            throw new Error(`Unknown ${JSON.stringify(position)} position`);
        }
    }
}
function Heading({ title, titleStyle, titleClass, subtitle, subtitleStyle, subtitleClass, position = 'top', }) {
    const { width, height, bottom } = hooks_1.usePlotContext();
    const defaultTitleStyle = {
        textAnchor: 'middle',
        fontSize: '16px',
        fontWeight: 'bold',
    };
    const defaultSubtitleStyle = {
        textAnchor: 'middle',
        fontSize: '14px',
        color: 'gray',
    };
    const bottomHeigth = height - bottom;
    const y = yTranslation(position, bottomHeigth);
    return (react_1.default.createElement("g", { transform: `translate(${width / 2}, ${y})` },
        react_1.default.createElement("text", { style: { ...defaultTitleStyle, ...titleStyle }, className: titleClass }, title),
        subtitle && (react_1.default.createElement("text", { transform: "translate(0, 20)", style: { ...defaultSubtitleStyle, ...subtitleStyle }, className: subtitleClass }, subtitle))));
}
exports.default = Heading;
