"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const d3_axis_1 = require("d3-axis");
const d3_selection_1 = require("d3-selection");
const react_1 = __importStar(require("react"));
const hooks_1 = require("../hooks");
const YAxis = ({ label, fontSize = 16, labelSpace = 30, showGridLines, labelStyle, min, max, paddingBottom = 0, paddingTop = 0, }) => {
    const axisRef = react_1.useRef(null);
    const { yScale, yScientific, plotHeight, plotWidth, left, top, width, } = hooks_1.usePlotContext();
    const { dispatch } = hooks_1.useDispatchContext();
    // Send min and max to main state
    react_1.useEffect(() => {
        dispatch({ type: 'yMinMax', value: { min, max } });
    }, [dispatch, min, max]);
    // Send paddings to main state
    react_1.useEffect(() => {
        if (paddingBottom < 0 || paddingBottom > 1) {
            throw new Error(`Padding bottom (${paddingBottom}) is not between 0 and 1`);
        }
        if (paddingTop < 0 || paddingTop > 1) {
            throw new Error(`Padding top (${paddingTop}) is not between 0 and 1`);
        }
        dispatch({
            type: 'yPadding',
            value: { min: paddingBottom, max: paddingTop },
        });
    }, [dispatch, paddingBottom, paddingTop]);
    react_1.useEffect(() => {
        if ((axisRef === null || axisRef === void 0 ? void 0 : axisRef.current) && yScale) {
            const axis = d3_axis_1.axisLeft(yScale);
            if (showGridLines) {
                axis.tickSizeInner(-plotWidth);
            }
            if (yScientific) {
                axis.tickFormat((val) => val.toExponential(2));
            }
            d3_selection_1.select(axisRef.current)
                .call(axis)
                .call((g) => {
                g.selectAll('.tick line')
                    .attr('stroke-opacity', showGridLines ? 0.5 : 1)
                    .attr('stroke-dasharray', showGridLines ? '2,2' : '0');
                g.selectAll('.tick text')
                    .attr('transform', `translate(${showGridLines ? -6 : 0},0)`)
                    .style('user-select', 'none');
            });
        }
    }, [axisRef, yScale, plotWidth, width, showGridLines, yScientific]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("g", { ref: axisRef, transform: `translate(${left}, 0)` }),
        label && (react_1.default.createElement("text", { transform: `translate(${left - fontSize - labelSpace - (yScientific ? 14 : 0)}, ${top + plotHeight / 2})rotate(-90)`, dy: fontSize, textAnchor: "middle", fontSize: fontSize, style: labelStyle }, label))));
};
exports.default = YAxis;
