"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDispatchContext = exports.usePlotContext = exports.DispatchContext = exports.PlotContext = void 0;
const react_1 = require("react");
exports.PlotContext = react_1.createContext({
    xScientific: false,
    yScientific: false,
});
exports.DispatchContext = react_1.createContext({
    dispatch: null,
});
function usePlotContext() {
    const context = react_1.useContext(exports.PlotContext);
    if (!context) {
        throw new Error('Plot compound component outside Plot context');
    }
    return context;
}
exports.usePlotContext = usePlotContext;
function useDispatchContext() {
    const context = react_1.useContext(exports.DispatchContext);
    if (!context) {
        throw new Error('Plot compound component outside Dispatch context');
    }
    return context;
}
exports.useDispatchContext = useDispatchContext;
